image: node:12-alpine

stages:
  - requirements
  - analyze
  - docker
  - deploy
  
services:
  - docker:stable-dind
  - mongo:4.2-rc-bionic
  - redis:5-alpine

variables:
  # When using dind, it's wise to use the overlayfs driver for improved performance.
  DOCKER_DRIVER: overlay2
  # Since the service docker:dind will create the certificates, we need to have the
  # certificate shared between the service and the job container.
  # https://about.gitlab.com/2019/07/31/docker-in-docker-with-docker-19-dot-03/
  DOCKER_TLS_CERTDIR: "/certs"
  
get_dependencies:
  stage: requirements
  script:
   - apk update
   #- apk --no-cache add --virtual builds-deps build-base python  
   - npm install
  cache:
   paths:
    - node_modules/
  artifacts:
    paths:
      - node_modules/
      
#analyze:
#  stage: analyze
#  image: ciricihq/gitlab-sonar-scanner
#  script:
#    - sonar-scanner -Dsonar.host.url=https://sonarqube.messenkrypt.xyz -Dsonar.gitlab.project_id=$CI_PROJECT_ID -Dsonar.projectVersion=$CI_BUILD_ID -Dsonar.gitlab.commit_sha=$CI_BUILD_REF -Dsonar.gitlab.ref_name=$CI_BUILD_REF_NAME -Dsonar.login=$SONAR_TOKEN
#  allow_failure: true
  
#docker-branch:
#  stage: docker
#  image: docker
#  script:
#    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD registry.gitlab.com
#    - docker build -f DockerfileCI -t registry.gitlab.com/mess-enkrypt/server-stuff/alpha-serveur/mess-enkrypt-api:$CI_COMMIT_SHORT_SHA .
#    - docker push registry.gitlab.com/mess-enkrypt/server-stuff/alpha-serveur/mess-enkrypt-api:$CI_COMMIT_SHORT_SHA
#  only:
#    - feature/*
    
docker:
  stage: docker
  image: docker
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD registry.gitlab.com
    - docker build -f DockerfileCI -t $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_NAME .
    - docker tag $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_NAME $CI_REGISTRY_IMAGE:latest
    - docker push $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_NAME
    - docker push $CI_REGISTRY_IMAGE:latest
  only:
      - develop
      - master
  allow_failure: false
  
docker-worker:
  stage: docker
  image: docker
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD registry.gitlab.com
    - docker build -f DockerfileCI -t $CI_REGISTRY_IMAGE/worker:$CI_COMMIT_REF_NAME .
    - docker tag $CI_REGISTRY_IMAGE/worker:$CI_COMMIT_REF_NAME $CI_REGISTRY_IMAGE/worker:latest
    - docker push $CI_REGISTRY_IMAGE/worker:$CI_COMMIT_REF_NAME
    - docker push $CI_REGISTRY_IMAGE/worker:latest
  only:
    - develop
    - master
  allow_failure: false
  
deploy-develop:
  stage: deploy
  image: alpine
  script:
    - apk update
    - 'which ssh-agent || ( apk add openssh-client )'
    - eval $(ssh-agent -s)
    - echo "$SSH_PRIVATE_KEY_DEPLOY" > deploy.pem
    - chmod 400 deploy.pem
    - ssh-add deploy.pem
    - mkdir -p ~/.ssh
    - 'echo -e "Host *\n\tStrictHostKeyChecking no\n\n" > ~/.ssh/config'
    - ssh ci@messenkrypt.loiu92.com "export COMPOSE_HTTP_TIMEOUT=$COMPOSE_HTTP_TIMEOUT && cd /home/ci/messenkrypt-landing-page-api-develop/ && docker-compose pull && docker-compose up -d --scale worker=3"
  environment:
    name: develop
    url: https://api.dev.landing-page.messenkrypt.com
  only:
    - develop

deploy-master:
  stage: deploy
  image: alpine
  script:
    - apk update
    - 'which ssh-agent || ( apk add openssh-client )'
    - eval $(ssh-agent -s)
    - echo "$SSH_PRIVATE_KEY_DEPLOY" > deploy.pem
    - chmod 400 deploy.pem
    - ssh-add deploy.pem
    - mkdir -p ~/.ssh
    - 'echo -e "Host *\n\tStrictHostKeyChecking no\n\n" > ~/.ssh/config'
    - ssh ci@ssh.messenkrypt.com "export COMPOSE_HTTP_TIMEOUT=360 && cd /home/ci/landing-page-back-master/ && docker-compose pull && docker-compose up -d --scale worker=3"
  only:
    - master
  when: manual
